push = require 'push'

Class = require 'Class'

require 'Tiles'

require 'Arrow'

WINDOW_WIDTH = 720
WINDOW_HEIGHT = 916

VIRTUAL_WIDHT = 368
VIRTUAL_HEIGHT = 468

TOTAL_TILES = 49

tileX = 15
tileY = 15
tiles = {}
acc_tileX = 0
acc_tileY = 0

function love.load()
    love.graphics.setDefaultFilter('nearest', 'nearest')

    love.window.setTitle('Tiles and Arrow')

    font = love.graphics.newFont('font.ttf', 7)

    love.graphics.setFont(font)

    sounds = {
        ['turn'] = love.audio.newSource('sounds/turn.wav', 'static'),
        ['redtile'] = love.audio.newSource('sounds/redtile.wav', 'static'),
        ['move'] = love.audio.newSource('sounds/move.wav', 'static'),
        ['greentile'] = love.audio.newSource('sounds/greentile.wav', 'static')
    }

    push:setupScreen(VIRTUAL_WIDHT, VIRTUAL_HEIGHT, WINDOW_WIDTH, WINDOW_HEIGHT, {
        fullscreen = false,
        resizable = true,
        vsync = true,
        canvas = false
    })

    love.graphics.setColor(1, 1, 1, 1)

    for i = 1, TOTAL_TILES
    do
        if acc_tileX >= 343 then
            acc_tileY = acc_tileY + 49
            acc_tileX = 0
        end

        table.insert(tiles, Tiles(tileX + acc_tileX, tileY + acc_tileY, 42, 42))
        acc_tileX = acc_tileX + 49

    end

    arrow = Arrow(39, 235, 0)

    love.keyboard.keysPressed = {}
    -- Aquí vas a settear los cuadrados de colores y otras variables de pertinencia jugable.
    -- También acá vas a colocar el gamestate
end

function love.resize(w, h)
    push:resize(w, h)
end

function love.keypressed(key)

    love.keyboard.keysPressed[key] = true

    if key == 'escape' then
        love.event.quit()
    end
    
end

function love.keyboard.wasPressed(key)
    if love.keyboard.keysPressed[key] then
        return true
    else
        return false
    end
end

function love.update(dt)

    -- Mecanismo lógico del juego.
    love.keyboard.keysPressed = {}
end


function love.draw()

    push:start()

    love.graphics.clear((50/255), (50/255), (50/255), 1)

    -- Cambios de menús y cosas
    -- Mensajes de UI y rendereo de todo lo demás

    displayScore()

    for i = 1, TOTAL_TILES 
    do
        
        if i == 1 or i == 10 or i == 26 or i == 46 then -- Amarillo
            love.graphics.setColor((255/255), (255/255), 0, 1)
        elseif i == 2 or i == 13 or i == 18 or i == 25 or i == 28 or i == 37 or i == 42 or i == 48 then -- Rojo
            love.graphics.setColor((255/255), 0, 0, 1)
        elseif i == 3 or i == 12 or i == 32 then -- Lila
            love.graphics.setColor((178/255), (161/255), (199/255), 1)
        elseif i == 5 or i == 30 then -- Naranja
            love.graphics.setColor((227/255), (108/255), (10/255), 1)
        elseif i == 6 then -- Turquesa
            love.graphics.setColor((75/255), (172/255), (198/255), 1)
        elseif i == 7 then -- Morado
            love.graphics.setColor((112/255), (48/255), (160/255), 1)
        elseif i == 8 or i == 14 or i == 20 or i == 22 or i == 29 or i == 31 or i == 33 or i == 35 or i == 39 or i == 43 or i == 47 or i == 49 then -- Blanco
            love.graphics.setColor((255/255), (255/255), (255/255), 1)
        elseif i == 9 then -- Azul Claro
            love.graphics.setColor((0/255), (176/255), (210/255), 1)
        elseif i == 11 or i == 21 or i == 38 then -- Azul Sucio
            love.graphics.setColor((84/255), (141/255), (212/255), 1)
        elseif i == 15 or i == 17 or i == 19 or i == 34 then -- Ambar
            love.graphics.setColor((255/255), (192/255), (0/255), 1)
        elseif i == 16 then -- Azul aun mas claro parce
            love.graphics.setColor((146/255), (205/255), (220/255), 1)
        elseif i == 27 then
            love.graphics.setColor((0/255), (176/255), (80/255), 1)
        end 

        tiles[i]:render()

    end

    Arrow:render()

    push:finish()

end

function displayScore()

    love.graphics.setFont(font)


end